/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                                  Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007      by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2011-2012	by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: start.S 2106 2011-06-21 13:46:09Z ertl-honda $
 */
        
/*
 *  ͥбΥȥåץ⥸塼(SH34)
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */
#include "kernel_impl.h"

    .text
    .extern __kernel_bsssecinib_table
    .extern __kernel_tnum_bsssec
    .extern __kernel_datasecinib_table
    .extern __kernel_tnum_datasec
    .global _start
    .align  2
_start:
    /*
     *  SR롣
     *  MD=1, RB=0, BL=0, I3I0=f(ߥޥ)
     */
    mov.l _init_sr, r0
    ldc   r0, sr

    /*
     *  R7_BANK11ˤ󥿥ƥȤȤ
     */
    mov   #0x01, r0
    ldc   r0, r7_bank

    /*
     *  󥿥ƥѤΥåν
     */
    mov.l  _kernel_istkpt_p, r1
    mov.l  @r1, r15

    /*
     *  _hardware_init_hook ƤӽФ(0Ǥʤ)
     *
     *  åȥϡɥ˰¸ɬפʽϡ
     *  hardware_init_hookȤؿѰդ롥
     */
start_0:
    mov.l  _hardware_init_hook_p, r0
    tst    r0, r0
    bt     start_1
    jsr    @r0
     or     r0, r0
    
    /*
     * bss򥯥ꥢ
     */
start_1:
    mov.l   __kernel_region_mask_sta, r7
    mov.l   __kernel_bsssecinib_table_sta, r0 /* ơ֥Υɥ쥹 */
    mov   #0, r1 /* ơ֥Υǥå: i */
    mov.l   __kernel_tnum_bsssec_sta, r2 
    mov.l   @r2, r2 /* ơ֥ǿ: num */
	mov   #0, r3 /*  */
start_bss_2:
    cmp/hi  r1, r2 /* 롼׽λȽ: i < num */
    bf      start_3
    mov.l   @(0,r0), r4 /* bssƬ */
    mov.l   @(4,r0), r5 /* bssνλ */
	cmp/hs  r5, r4      /* bss */
	bt	    start_bss_4 /* ʤмbss */
    or      r7, r4
    or      r7, r5
    nop
start_bss_3:
    /*
     *  bssΰϡ4byte˥饤󤵤Ƥ
     *  äơ4byteĥǡ򥳥ԡƤ
     */
	mov.l   r3, @r4     /* bssΰ0ǽ */
	add     #4, r4      /* Ϥ */
	cmp/hi  r4, r5      /* bssνλϤޤ褿 */
	bt      start_bss_3 /* λϤʤнλ */
    nop
start_bss_4:
    add     #8, r0 /* ơ֥Υɥ쥹򥤥󥯥 4byte * 2 -> 8 */
    add     #1, r1 /* ơ֥Υǥå򥤥󥯥: i++ */
    bra     start_bss_2
    nop


    /*
     *  dataROMбˡ
     *
     *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
     *  ԡ롥
     */
start_3:
    mov.l   __kernel_datasecinib_table_sta, r0 /* ơ֥Υɥ쥹 */
    mov     #0, r1 /* ơ֥Υǥå: i */
    mov.l   __kernel_tnum_datasec_sta, r2
    mov.l   @r2, r2 /* ơ֥ǿ: num */
start_data_2:
    cmp/hi  r1, r2 /* 롼׽λȽ: i < num */
    bf      start_5
    mov.l   @(0,r0), r3 /* dataƬ -> ѿɥ쥹 */
    mov.l   @(4,r0), r4 /* dataνλ */
    mov.l   @(8,r0), r5 /* idataƬ -> ͤΥɥ쥹 */
	cmp/hs  r4, r3      /* data */
	bt	    start_data_4    /* ʤмdata */
    or      r7, r3
    or      r7, r4
    or      r7, r5
    nop
start_data_3:
    /*
     *  idataΰϡROMΰΤᡤ饤󤵤ʤ
     *  äơ1byteĥǡ򥳥ԡƤ
     */
	mov.b   @r5, r6         /* idataͤ */
    mov.b   r6, @r3         /* idataͤdataΥɥ쥹إȥ */
	add     #1, r3          /* dataμϤ */
	add     #1, r5          /* idataμϤ */
	cmp/hi  r3, r4          /* dataνλϤޤ褿 */
	bt      start_data_3    /* λϤʤнλ */
    nop
start_data_4:
    add     #12, r0 /* ơ֥Υɥ쥹򥤥󥯥 4byte * 3 -> 12 */
    add     #1, r1 /* ơ֥Υǥå򥤥󥯥: i++ */
    bra     start_data_2
    nop
        
    /*
     *  _software_init_hook ƤӽФ0 Ǥʤˡ
     *
     *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
     *  ϡsoftware_init_hook ȤؿѰդ
     *  褤
     */
start_5:    
    mov.l  _software_init_hook_p, r0
    tst    r0, r0
    bt     start_6        
    jsr    @r0
     nop
        
start_6:

	/*
	 *  FPUν
	 */
#ifdef FPU_ENABLE
	/*
	 *  gccѤǡ___fpscr_valuesˤ
	 */
	mov.l _set_fpscr_p, r1
    mov.l _fpscr_init_p, r4
	jsr   @r1
     nop
	lds   r3, fpscr 
	/*
	 *  FPUͭ
	 */
	stc   sr, r0
	mov.l _sr_fpu_enable, r1
	and   r0, r1
	ldc   r1, sr
#endif /* FPU_ENABLE */

    /*    
     *  ͥư
     */
    mov.l  _sta_ker_p, r0
    jsr    @r0
     nop


    .align 4
_init_sr:    
    .long (0x400000f0)
_kernel_istkpt_p:
    .long __kernel_istkpt
_hardware_init_hook_p:    
    .long _hardware_init_hook
__kernel_bsssecinib_table_sta:
    .long   __kernel_bsssecinib_table
__kernel_tnum_bsssec_sta:
    .long   __kernel_tnum_bsssec
__kernel_datasecinib_table_sta:
    .long   __kernel_datasecinib_table
__kernel_tnum_datasec_sta:
    .long   __kernel_tnum_datasec
__kernel_region_mask_sta:
    .long 0xa0000000
_software_init_hook_p:    
    .long _software_init_hook    
_sta_ker_p:    
    .long _sta_ker
#ifdef FPU_ENABLE
_set_fpscr_p:
	.long ___set_fpscr
_sr_fpu_enable:
	.long   ~0x00008000
_fpscr_init_p:
	.long    FPSCR_INIT 
#endif /* FPU_ENABLE */
